#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	n	31		/* dlugosc slowa kodowego		*/
#define	r	10		/* stopien wielomianu generujacego kod	*/
#define	d	5		/* minimalna odleglosc miedzy slowami	*/

/* wielomian generujucy kod */
int	wg[r+1] = {1,1, 1,0,1, 1,0,1, 0,0,1};
		  // 3    5      5      1
		 // wg[0] - wspolczynnik przy najwyzszej potedze

void Calculate_Syndrom(int slowo[], int syndrom[])
{
	/* wg[r+1]    - wielomian generujacy 	*/
	/* slowo[n]   - wektor kodowy   	*/
	/* syndrom[r] - obliczony syndrom 	*/

	// wstawic obliczanie syndromu
}

void main()
{
	int	F2[n], C[n];	/* elementy ciagu 	*/
	int	F3[r];	/* elementy syndromu 	*/

	int	waga,h = 0,i,j,k;
	char	message[256]="101010101011001100111", error[256];

	printf("------------------ Kod BCH ------------------\n");
	printf("                                                ");
	for (i=0; i<n-r; i++) printf("_");
	printf("\nPodaj ciag do wyslania (%d znakow '0' lub '1'): ", n-r);
	scanf("%s", message);
        fflush(stdin);
        
	i=strlen(message);

	if (i < n-r)
	for (j=i; j<n-r; j++) message[j]='0';

	message[n-r]='\0';

	for (i=0; i<n-r; i++)
		F2[i] = message[i]-'0';
	for (i=n-r; i<n; i++)
		F2[i] = 0;

	Calculate_Syndrom(F2,F3);

	for (i=n-r; i<n; i++)
		F2[i] = F3[i-n+r];

	printf("Zakodowany ciag (wektor kodowy): ");
	for (i=0; i<n; i++)
	{ printf("%d", F2[i]); C[i] = F2[i]; }

	printf("\n");

	printf("                                            ");
	for (i=0; i<n; i++) printf("_");
	printf("\nPodaj blad wprowadzony do wektora kodowego: ");
	scanf("%s", error);
        fflush(stdin); 

	i=strlen(error);

	if (i < n)
	for (j=i; j<n; j++) error[j]='0';

	error[n]='\0';

	//getchar();

	for (i=0; i<n; i++) {
		k = error[i] - '0';
		F2[i] = (F2[i] + k + 2) % 2;
	}

	printf("Odebrany ciag: ");
	for (i=0; i<n; i++)
		printf("%d", F2[i]);
	printf("\n");

	waga = 0;
	Calculate_Syndrom(F2,F3);
	for (i=0; i<r; i++)
		if (F3[i] > 0) waga++;

	printf("Syndrom odebranego ciagu: ");
	for (i=0; i<r; i++)
		printf("%d", F3[i]);
	printf("\n");

	printf("Waga syndromu: %d\n", waga);

	if (waga <= ((d-1)/2)) {
		printf("W ciagu informacyjnym nie ma bledu - nie ma potrzeby korekcji\n");
	} else {
		printf("W odebranym ciagu sa bledy - rozpoczynam korekcje\n");

		do {          // shift right
			h++;
			k = F2[n-1];
			for (i=n-2; i>=0; i--)
				F2[i+1] = F2[i];
			F2[0] = k;

			printf("Przesuniety ciag: ");
			for (i=0; i<n; i++)
				printf("%d", F2[i]);
			printf("\n");

			waga = 0;
			Calculate_Syndrom(F2,F3);

			for (i=0; i<r; i++)
				if (F3[i] > 0) waga++;

			printf("Syndrom ciagu odebranego: ");
			for (i=0; i<r; i++)
				printf("%d", F3[i]);
			printf("\n");

			printf("Waga syndromu: %d\n", waga);

			printf("<Enter>\n");
			getchar();

		} while ((waga > ((d-1)/2))&&(h <= (n-r)));

		if (waga <= (d-1)/2) {
			for (i=n-r; i<n; i++)
				F2[i] = (F2[i] + F3[i-n+r]) % 2;
		do { //shift right n-h positions = shift left h positions
				h++;
				k = F2[n-1];
				for (i=n-2; i>=0; i--)
					F2[i+1] = F2[i];
				F2[0] = k;
			} while (h != n);

			printf("Koniec procesu korekcji.\nSkorygowany ciag: ");
			for (i=0; i<n; i++)
				printf("%d", F2[i]);
			printf("\nNadany ciag:      ");
			for (i=0; i<n; i++)
				printf("%d", C[i]);
			printf("\n");

		} else {
			printf("\nCiagu nie da sie skorygowac!\n");
		}
	}
	printf("\nKoniec programu!\n<Enter>\n");
	getchar();
}